/*********************************************
 * vim:sw=8:ts=8:si:et
 * To use the above modeline in vim you must have "set modeline" in your .vimrc
 * Author: Guido Socher 
 * Modified by : Clément Notin (removing of TCP functions) for "Erasme - Département du Rhône" (France) in July 2008
 * You should use original code from http://www.tuxgraphics.com/electronics/200611/embedded-webserver.shtml (end of page)
 * Email : clement@notin.org
 * Website : reseau.erasme.org
 * Copyright: GPL V2
 *
 * IP/ARP/UDP functions (no TCP - Clément)
 *
 * Chip type           : ATMEGA168 with ENC28J60
 *********************************************/
//@{
#ifndef IP_ARP_UDP_TCP_H
#define IP_ARP_UDP_TCP_H
#include <avr/pgmspace.h>

// you must call this function once before you use any of the other functions:
extern void init_ip_arp_udp_tcp(uint8_t *mymac,uint8_t *myip);
//
extern uint8_t eth_type_is_arp_and_my_ip(uint8_t *buf,uint16_t len);
extern uint8_t eth_type_is_ip_and_my_ip(uint8_t *buf,uint16_t len);
extern void make_arp_answer_from_request(uint8_t *buf);
extern void make_echo_reply_from_request(uint8_t *buf,uint16_t len);
extern void make_udp_reply_from_request(uint8_t *buf,char *data,uint8_t datalen,uint16_t port);


extern void init_len_info(uint8_t *buf);


#endif /* IP_ARP_UDP_TCP_H */
//@}
