/*********************************************
 * Author: Clément Notin for "Erasme - Département du Rhône" (France) in July 2008
 * Email : clement@notin.org
 * Website : reseau.erasme.org
 * Copyright: GPL V2
 * See http://www.gnu.org/licenses/gpl.html
 *
 * Udpcom module for main program. Basic code to send (receiving is not implemented) UDP packets.
 * Linux only !
 *
 *********************************************/
#include <stdio.h> //fprintf(), perror()
#include <stdlib.h> //exit()
#include <string.h> //memset()
#include <arpa/inet.h>

int sockfd_s, sockfd_r;
unsigned int fromaddrLen;
struct sockaddr_in destaddr, servaddr, fromaddr;

void udpInit(char *destIp, int portnum)
{
        in_addr_t dest;

        dest=inet_addr(destIp);
        if (dest==INADDR_NONE)
        {
                fprintf(stderr,"Error: IP addr. not valid\n");
                exit(1);
        }

        destaddr.sin_family = AF_INET;
        destaddr.sin_addr.s_addr = dest;
        destaddr.sin_port = htons(portnum);

        servaddr.sin_family = AF_INET;
        servaddr.sin_addr.s_addr = inet_addr("192.168.0.142");
        servaddr.sin_port = htons(portnum);
	memset(&servaddr.sin_zero, 0, sizeof(servaddr.sin_zero));

        if ((sockfd_s = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP)) < 0)
        {
                perror("open server socket failed");
                exit(1);
        }
        if ((sockfd_r = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP)) < 0)
        {
                perror("open sender socket failed");
                exit(1);
        }
        if (bind(sockfd_r, (struct sockaddr *)&servaddr, sizeof(servaddr)))
        {
                perror("bind socket failed");
                exit(1);
        }

        fromaddrLen = sizeof(fromaddr);
}

void udpSend(char *data, unsigned int size)
{
    if(sendto(sockfd_s,data, size, 0, (struct sockaddr *)&destaddr, sizeof(destaddr)) == -1){
        perror("sendto failed");
        exit(1);
    }
}

void udpReceive(char *buffer)
{
    int nRetVal = 0;
    struct timeval tv;
    tv.tv_usec = 0;
    tv.tv_sec = 5;
    fd_set fds;

    FD_ZERO(&fds);
    FD_SET(sockfd_r, &fds); 

    nRetVal=select(FD_SETSIZE,&fds,NULL,NULL,&tv);

    if(nRetVal>0) // It means data is available.
    {
            if(FD_ISSET(sockfd_r,&fds))
            {
                    recvfrom(sockfd_r, buffer, 2, 0, (struct sockaddr *)&fromaddr, &fromaddrLen);
            }
    }
    else if(nRetVal==0)  // it means timeout
            {
            printf("Binem is not responding. It could be unreachable (check your network : try to ping it) or powered off.\n");
            }
}
