#!/usr/bin/python
# -*- coding: utf8 -*-

import sys, time
from PyQt4 import QtCore, QtGui
from ui_mainwindow import Ui_MainWindow
import Image
import ImageQt
from socket import *


def serverIsReady():
    getInfosFromGui()
    global ip
    global port
    sockClient.sendto("\6?", (ip, port))
    try:
        buffer = sockServer.recvfrom(2)
        buffer=buffer[0]

        if buffer[1] == "y":
            return True
        else:
            return False
    except: #timeout
        QtGui.QMessageBox.critical(MainWindow, "Network timeout", "Binem is not responding.\nIt could be unreachable (check \
your network : try to ping it) or powered off.\n\
You should exit this application too.")
        return True


def lineIsOk():
    try:
        buffer = sockServer.recvfrom(2)
        buffer=buffer[0]

        if buffer[1] == "y":
            return True
        else:
            return False
    except: #timeout
        QtGui.QMessageBox.critical(MainWindow, "Network timeout", "Binem is not responding.\nIt could be unreachable (check \
your network : try to ping it) or powered off.\n\
You should exit this application too.")
        return True

def getInfosFromGui():
    global offset, ip, port
    offset = (MainWindow.offset.value()-1)*3
    ip = MainWindow.ip.text()
    port = eval(str(MainWindow.port.text()))


class MainWindow(QtGui.QMainWindow, Ui_MainWindow):
    def __init__(self, parent=None):
        QtGui.QMainWindow.__init__(self, parent)
        self.setupUi(self)

    @QtCore.pyqtSignature("")
    def on_browseSend_clicked(self):
        self.pictureLocation = unicode(QtGui.QFileDialog.getOpenFileName(self, "Give me your picture !", "/home/clem/Bureau", "*.bmp"))
        if(self.pictureLocation != ""):
            self.sendPictureShow.setPixmap(QtGui.QPixmap(self.pictureLocation))

    @QtCore.pyqtSignature("")
    def on_send_clicked(self):
        picture = Image.open(self.pictureLocation).rotate(180).transpose(Image.FLIP_LEFT_RIGHT)
        pictureQt = ImageQt.ImageQt(picture)
        pictureData = pictureQt.bits().asstring(19200)

        if serverIsReady():
            global offset, ip, port
            sockClient.sendto("\1%c" % (offset), (ip, port))
            time.sleep(0.1)
            for i in range(0,80):
                    sockClient.sendto("\2%c" % (i) +pictureData[240*i : 240*(i+1)], (ip, port))
                    while not lineIsOk():
                        print "Error sending line %d, retrying" % (i)
                        sockClient.sendto("\2%c" % (i) +pictureData[240*i : 240*(i+1)], (ip, port))
                    print i
            sockClient.sendto("\3a", (ip, port))
        else :
            QtGui.QMessageBox.warning(self, "Not ready", "Binem is busy.\nMaybe another application \
is chatting with him.\nPlease wait a minute.")


    @QtCore.pyqtSignature("")
    def on_refresh_clicked(self):
        if serverIsReady():
            global offset, ip, port
            sockClient.sendto("\4%c" % (offset), (ip, port))
        else:
            QtGui.QMessageBox.warning(self, "Not ready", "Binem is busy.\nMaybe another application \
is chatting with him.\nPlease wait a minute.")


    @QtCore.pyqtSignature("")
    def on_clear_clicked(self):
        if serverIsReady():
            global ip, port
            sockClient.sendto("\5a", (ip, port))
        else:
            QtGui.QMessageBox.warning(self, "Not ready", "Binem is busy.\nMaybe another application \
is chatting with him.\nPlease wait a minute.")


    @QtCore.pyqtSignature("")
    def on_browseConvert_clicked(self):
        self.pictureToConvertLocation = unicode(QtGui.QFileDialog.getOpenFileName(self, "Give me your picture !", "/home/clem/Bureau", "Images ( *.jpg *.jpeg *.bmp *.png *.gif )"))
        if(self.pictureToConvertLocation != ""):
            self.picture = Image.open(self.pictureToConvertLocation).resize((480,320)).convert("1")
            picturePixmap = QtGui.QPixmap().fromImage(ImageQt.ImageQt(self.picture))
            self.convertPictureShow.setPixmap(picturePixmap)

    @QtCore.pyqtSignature("")
    def on_rotateclockwise_clicked(self):
        self.picture = Image.open(self.pictureToConvertLocation).rotate(-90).resize((480,320)).convert("1")
        picturePixmap = QtGui.QPixmap().fromImage(ImageQt.ImageQt(self.picture))
        self.convertPictureShow.setPixmap(picturePixmap)

    def on_rotatecounterclockwise_clicked(self):
        self.picture = Image.open(self.pictureToConvertLocation).rotate(90).resize((480,320)).convert("1")
        picturePixmap = QtGui.QPixmap().fromImage(ImageQt.ImageQt(self.picture))
        self.convertPictureShow.setPixmap(picturePixmap)


    @QtCore.pyqtSignature("")
    def on_save_clicked(self):
        self.picture.save(unicode(QtGui.QFileDialog.getSaveFileName(self, "Give me your picture !", "/home/clem/Bureau", "*.bmp")), "BMP")



if __name__ == "__main__":
    app = QtGui.QApplication(sys.argv)
    MainWindow = MainWindow()
    MainWindow.show()

    sockClient = socket(AF_INET,SOCK_DGRAM)

    sockServer = socket(AF_INET,SOCK_DGRAM)
    sockServer.bind(("192.168.0.142", 1200))

    sockServer.settimeout(5)

    app.exec_()
    sockClient.close()
    sockServer.close()
