/*********************************************
 * Author: Clément Notin for "Erasme - Département du Rhône" (France) in July 2008
 * Email : clement@notin.org
 * Website : reseau.erasme.org
 * Copyright: GPL V2
 * See http://www.gnu.org/licenses/gpl.html
 *
 * Define codes useful speaking with binem screen (refer to BVGP protocol doc)
 * Not full list ! some codes are missing (because we don't need them) and some listed aren't used
 *********************************************/

#ifndef _BVGP_H_
#define _BVGP_H_


#define GET_STATUS 0xA0
#define GET_CONFIG_REG 0xA2
#define SET_CONFIG_REG 0xA3
#define GET_MEMORY_SIZE 0xA4
#define GET_TEMPERATURE 0xA5
#define GET_DISPLAY_INFO 0xA6
#define GET_IMAGE_SIZE 0xA7
#define GET_ROW_SIZE 0xA8
#define DISPLAY_REFRESH 0xA9
#define GET_FIRMWARE_VERS 0xAE
#define GET_CELL_REF 0xAF
#define GET_CURSOR_POS 0xB0
#define SET_CURSOR_POS 0xB1
#define SEND_IMAGE_BLOCK 0xE1
#define POWER_OFF 0xF2

#define NO_ERRORS 0
#define CRC_ERROR 1
#define BAD_PARAMETER 2
#define ERROR_SYSTEM 3
#define PARAM_OVER_RANGE 4
#define INTERNAL_HW_ERROR 5
#define NO_MEMORY_AVAILABLE 6
#define POWER_ERROR 7
#define IMAGE_INTERRUPT_STATUS 16

#define MAGIC_NUMBER_ERROR 0
#define CRS_ERROR_CRC 1
#define TCF_ERROR_CRC 2

#define RAM_ERROR 0
#define EEPROM_ERROR 1
#define TEMPERATURE_ERROR 2
#define PLL_LOCK_ERROR 3


#define FIRST_ROW_REQUEST 0
#define NEXT_ROW_REQUEST 1
#define END_OF_REFRESH 2

#endif
 
